{-# LANGUAGE FlexibleContexts #-}

module Sem13 where

import Control.Monad.Except
import Control.Arrow
import Data.Monoid
import Data.Maybe
import Data.List


-- Вывод типов.
-- Сегодня будет не самая обычная практика по модулю того, что я почти ничего не буду говорить. Нам нужно будет написать алгоритм вывода типов для просто типизированного лямбда-исчисления.
-- Для этого нам понадобятся некоторые определения:
-- Далее, везде, где написан undefined необходимо написать реализацию

infixl 2 :@
infixr 3 :->

type Symb = String

-- Терм
data Expr =
    Var Symb
    | Expr :@ Expr
    | Lam Symb Expr
    deriving (Eq,Show,Read)

-- Тип
data Type =
    TVar Symb
    | Type :-> Type
    deriving (Eq,Show)

-- Контекст
newtype Env = Env [(Symb,Type)]
    deriving (Eq,Show)

-- Подстановка
newtype SubsTy = SubsTy [(Symb, Type)]
    deriving (Eq,Show)

-- Всякие вспомогательные штуки
-- Свободные переменные терма(уже писали в большой домашке)
freeVars :: Expr -> [Symb]
freeVars (Var v) = [v]
freeVars (a :@ b) = freeVars a `union` freeVars b
freeVars (Lam v e) = freeVars e \\ [v]

-- Свободные типовые переменные. Есть ли в STT связанные переменные в типах?
freeTVars :: Type -> [Symb]
freeTVars = undefined

-- Расширение контекста
extendEnv :: Env -> Symb -> Type -> Env
extendEnv = undefined

-- Свободные типовые переменные в контексте
freeTVarsEnv :: Env -> [Symb]
freeTVarsEnv = undefined

-- Контекст можно рассматривать еще и как частичную функцию из множества переменных во множество типов
appEnv :: (MonadError String m) => Env -> Symb -> m Type
appEnv = undefined

-- Подстановку можно применять к типу
appSubsTy :: SubsTy -> Type -> Type
appSubsTy = undefined

-- И к контексту
appSubsEnv :: SubsTy -> Env -> Env
appSubsEnv = undefined

-- Их можно комбинировать
composeSubsTy :: SubsTy -> SubsTy -> SubsTy
composeSubsTy = undefined

-- И подстановки образуют моноид
instance Monoid SubsTy where
    mempty = SubsTy []
    mappend = composeSubsTy


-- Наконец, реализуйте алгоритм унификации для двух типов
unify :: (MonadError String m) => Type -> Type -> m SubsTy
unify = undefined

-- Реализуйте алгоритм составления системы ограничений для терма в заданном контексте и начальном типе. Обратите особое внимание на случаи аппликации и абстракции
equations :: (MonadError String m) => Env -> Expr -> Type -> m [(Type,Type)]
equations = undefined

-- Воспользовавшись им, напишите алгоритм поиска главной пары -- главного типа и контекста, в котором верно утверждение о типизации данного терма
principlePair :: (MonadError String m) =>  Expr -> m (Env,Type)
principlePair = undefined
